Program TriDpohyb;
uses Crt,
     Graph,
     SchGraph;

Type ViewPort=record
               x1,y1,x2,y2:integer;
              end;
Type KruhType=record
               x,y,r:integer;
               dx,dy:integer;
               c:byte;
              end;
const maxcircle=5;

var vp:viewport;
    kruh:array[1..maxcircle] of KruhType;
    an:integer;
    kk:char;

Procedure InitAnim;
begin
 InitGr;
end;

Procedure Screen(s:string;bool:boolean);
begin
 setfillstyle(1,0);
 if bool then bar(0,0,640,480);
 with vp do
  begin
   x1:=5;y1:=20;
   x2:=635;y2:=475;
   setcolor(15);
   rectangle(x1,y1,x2,y2);
   rectangle(x1,0,x2,y2);
   settextjustify(centertext,centertext);
   outtextxy(320,10,s);
  end;
end;

Procedure InitMojeData;
var i:integer;
begin
 screen('(C) Martin Schmidt,  Semestralna Praca: Pohyb Kruznic',true);
 randomize;
 for i:=1 to maxcircle do
  with kruh[i] do
   begin
    r:=random(20)+10;                   { Polomer }
    x:=random(490)+r+vp.x1+1;
    y:=random(100)+r+vp.y1+1;
    dx:=random(10);
    dx:=dx-2;
    dy:=random(7);
    dy:=dy-2;
    c:=random(7)+9;
    setcolor(c);
    circle(x,y,r);
   end;
end;

Procedure Circles(p,pl:integer;bool:boolean);
var i,ynew,xnew:integer;
begin
 InitMojeData;
 repeat
  for i:=1 to maxcircle do
   with kruh[i] do
    begin
     xnew:=x+dx;
     ynew:=y+dy;

     if (xnew+r>=vp.x2)then begin
      xnew:=vp.x2-r-1;
      dx:= -dx;end;
     if (xnew-r<vp.x1+1)then begin
      xnew:=vp.x1+r+1;
      dx:= -dx;end;
     if (ynew+r>vp.y2-1)then begin
      ynew:=vp.y2-r-2;
      dy:= -dy+p;end;
     if (ynew-r<vp.y1+1) then begin
      ynew:=vp.y1+r+1;
      dy:= -dy+p;end;
     if bool then
      begin
       setcolor(black);
       circle(x,y,r);
      end;
     x:=xnew;
     y:=ynew;
     setcolor(c);
     circle(x,y,r);
     dy:=dy+pl;
    end;
 until keypressed;
 kk:=readkey;
end;

Procedure Rotpal(d,h:byte);
var pal:palettetype;
    i,ii,pom:integer;
begin
 ii:=0;
 Getpalette(pal);
 repeat
  inc(ii);if ii=h then ii:=0;
  for i:=d to h do
   begin
    if i+ii>h then pom:=i+ii-h else pom :=i+ii;
    setpalette(i,pom);
   end;
 until keypressed;
 Setallpalette(pal);
end;

Procedure Anim01;
var i:integer;
begin
 screen('(C) Martin Schmidt,  Semestralna Praca: Rotacia Palety',true);
 for i:=1 to 90 do
  begin
   setcolor(i);
   circle(50+2*i,130,40);
   circle(300+2*i,130,i);
   circle(50+i,300,i);
  end;
 rotpal(1,14);
 kk:=readkey;
end;

Procedure Anim02(bool:boolean);
var p:pointer;
    io,jo,i,j,pl,pli,plj:integer;
begin
 screen('',true);
 setcolor(1);
 for i:=1 to 80 do
  begin
   line(0,0,8*i,480);
   line(640,0,8*i,480);
   line(0,480,8*i,0);
   line(640,480,8*i,0);
  end;
 screen('(C) Martin Schmidt,  Semestralna Praca: Prekreslovanie Ciary',false);
 setcolor(14);
 setwritemode(xorput);
 i:=vp.x1+1;j:=vp.y1+1;
 io:=i;jo:=j;
 if bool then line(320,240,io,jo);
 pli:=1;plj:=0;
 repeat
  i:=i+pli;
  j:=j+plj;
  if bool then line(320,240,io,jo);
  line(320,240,i,j);
  io:=i;jo:=j;
  if (i=vp.x2-1)and(j=vp.y1+1) then begin pli:=0;plj:=1;end;
  if (j=vp.y2-1)and(i=vp.x2-1) then begin pli:=-1;plj:=0;end;
  if (i=vp.x1+1)and(j=vp.y2-1) then begin pli:=0;plj:=-1;end;
  if (j=vp.y1+1)and(i=vp.x1+1) then begin pli:=1;plj:=0;end;
 until keypressed;
 setwritemode(normalput);
 kk:=readkey;
end;

Procedure Kresli(x,y,d,v:integer);
begin
 setfillstyle(9,14);
 setcolor(13);
 bar((x+d div 2)-an div 2,y,x+an,y+v);
 rectangle((x+d div 2)-an div 2,y,x+an,y+v);
 inc(an);
 if an>d then an:=1;
 {delay(8);}
end;

Procedure Anim03;
var p:pointer;
    pli,plj,i,j,x,y,d,v,xo,yo:integer;
begin
 an:=1;
 screen('',true);
 setcolor(1);
 for i:=0 to 80 do
  begin
   line(8*i,0,8*i,480);
   line(0,8*i,640,8*i);
  end;
 screen('(C) Martin Schmidt,  Semestralna Praca: Animovany Obdlznik',false);
 d:=100;v:=10;
 getmem(p,d*v);
 randomize;
 x:=320;y:=240;
 i:=1;j:=1;
 pli:=1;plj:=1;
 getimage(x,y,x+d,y+v,p^);
 kresli(x,y,d,v);
 xo:=x;yo:=y;
 repeat
  i:=random(2);
  i:=i-1;
  j:=random(2);
  j:=j-1;
  x:=x+pli*i;y:=y+plj*j;
  if (x>=vp.x2-1-d)or(x<=vp.x1+1) then pli:=pli*(-1);
  if (y>=vp.y2-1-v)or(y<=vp.y1+1) then plj:=plj*(-1);
  repeat
  until port[$3DA] and 8 = 8;
  putimage(xo,yo,p^,normalput);
  getimage(x,y,x+d,y+v,p^);
  kresli(x,y,d,v);
  xo:=x;yo:=y;
 until keypressed;
 kk:=readkey;
 freemem(p,d*v);
end;

begin
 InitAnim;
 Circles(1,1,true);
 Circles(1,0,true);
 Circles(1,-1,true);
 Circles(1,1,false);
 Anim01;
 Anim02(false);
 Anim02(true);
 Anim03;
 closegraph;
end.
